EnableExplicit

;{ CONSTANTS

#GDIPLUS_OK = 0
#GDIPLUS_ERROR = 1
#GDIPLUS_INVALID_PARAMETER = 2
#GDIPLUS_OUT_OF_MEMORY = 3
#GDIPLUS_OBJECT_BUSY = 4
#GDIPLUS_INSUFFICIENT_BUFFER = 5
#GDIPLUS_NOT_IMPLEMENTED = 6
#GDIPLUS_WIN32_ERROR = 7
#GDIPLUS_WRONG_STATE = 8
#GDIPLUS_ABORTED = 9
#GDIPLUS_FILE_NOT_FOUND = 10
#GDIPLUS_OVERFLOW = 11
#GDIPLUS_ACCESS_DENIED = 12
#GDIPLUS_UNKNOWN_IMAGE_FORMAT = 13
#GDIPLUS_FONT_FAMILY_NOT_FOUND = 14
#GDIPLUS_FONT_STYLE_NOT_FOUND = 15
#GDIPLUS_NOT_TRUETYPE_FONT = 16
#GDIPLUS_UNSUPPORTED_VERSION = 17
#GDIPLUS_NOT_INITIALIZED = 18
#GDIPLUS_PROPERTY_NOT_FOUND = 19
#GDIPLUS_PROPERTY_NOT_SUPPORTED = 20
#GDIPLUS_PROFILE_NOT_FOUND = 21

 
#GDIPLUS_JPG_ENCODER    = "image/jpeg"  ; file extensions: .jpeg,.jpe,.jpg,.jfif,.exif
#GDIPLUS_GIF_ENCODER    = "image/gif"   ; file extensions: .gif
#GDIPLUS_BMP_ENCODER    = "image/bmp"   ; file extensions: .bmp,.dib,.rle
#GDIPLUS_PNG_ENCODER    = "image/png"   ; file extensions: .png
#GDIPLUS_TIF_ENCODER    = "image/tiff"  ; file extensions: .tiff, .tif

#ImageFormatUndefined$  =   "{B96B3CA9-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatMemoryBMP$  =   "{B96B3CAA-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatBMP$        =   "{B96B3CAB-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatEMF$        =   "{B96B3CAC-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatWMF$        =   "{B96B3CAD-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatJPEG$       =   "{B96B3CAE-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatPNG$        =   "{B96B3CAF-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatGIF$        =   "{B96B3CB0-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatTIFF$       =   "{B96B3CB1-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatEXIF$       =   "{B96B3CB2-0728-11D3-9D7B-0000F81EF32E}" 
#ImageFormatIcon$       =   "{B96B3CB5-0728-11D3-9D7B-0000F81EF32E}"

Enumeration ;{ Pixel Format
#PixelFormatIndexed         = $00010000
#PixelFormatGDI             = $00020000
#PixelFormatAlpha           = $00040000
#PixelFormatPAlpha          = $00080000
#PixelFormatExtended        = $00100000
#PixelFormatCanonical       = $00200000 
#PixelFormatUndefined       = 0
#PixelFormatDontCare        = 0
#PixelFormat1bppIndexed     = (1 | ( 1 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
#PixelFormat4bppIndexed     = (2 | ( 4 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
#PixelFormat8bppIndexed     = (3 | ( 8 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
#PixelFormat16bppGrayScale  = (4 | (16 << 8) | #PixelFormatExtended)
#PixelFormat16bppRGB555     = (5 | (16 << 8) | #PixelFormatGDI)
#PixelFormat16bppRGB565     = (6 | (16 << 8) | #PixelFormatGDI)
#PixelFormat16bppARGB1555   = (7 | (16 << 8) | #PixelFormatAlpha | #PixelFormatGDI)
#PixelFormat24bppRGB        = (8 | (24 << 8) | #PixelFormatGDI)
#PixelFormat32bppRGB        = (9 | (32 << 8) | #PixelFormatGDI)
#PixelFormat32bppARGB       = (10 | (32 << 8) | #PixelFormatAlpha | #PixelFormatGDI | #PixelFormatCanonical)
#PixelFormat32bppPARGB      = (11 | (32 << 8) | #PixelFormatAlpha | #PixelFormatPAlpha | #PixelFormatGDI)
#PixelFormat48bppRGB        = (12 | (48 << 8) | #PixelFormatExtended)
#PixelFormat64bppARGB       = (13 | (64 << 8) | #PixelFormatAlpha  | #PixelFormatCanonical | #PixelFormatExtended)
#PixelFormat64bppPARGB      = (14 | (64 << 8) | #PixelFormatAlpha  | #PixelFormatPAlpha | #PixelFormatExtended)
#PixelFormat32bppCMYK       = (15 | (32 << 8))
#PixelFormatMax             = 16
EndEnumeration ;}

Enumeration ;{ Stream constants
 #STREAM_SEEK_SET   = 0
 #STREAM_SEEK_CUR   = 1
 #STREAM_SEEK_END   = 2 
EndEnumeration ;}

Enumeration ;{ Common Quality Mode
#QualityModeInvalid = -1
#QualityModeDefault =  0
#QualityModeLow     =  1 ; Best performance
#QualityModeHigh    =  2 ; Best rendering quality
EndEnumeration ;} 

Enumeration ;{ InterpolationMode
 #InterpolationModeInvalid     = #QualityModeInvalid
 #InterpolationModeDefault     = #QualityModeDefault
 #InterpolationModeLowQuality  = #QualityModeLow
 #InterpolationModeHighQuality = #QualityModeHigh
 #InterpolationModeBilinear
 #InterpolationModeBicubic
 #InterpolationModeNearestNeighbor
 #InterpolationModeHighQualityBilinear
 #InterpolationModeHighQualityBicubic
EndEnumeration ;} 

Enumeration ;{ SmoothingMode
  #SmoothingModeInvalid       = #QualityModeInvalid 
  #SmoothingModeDefault       = #QualityModeDefault
  #SmoothingModeHighSpeed     = #QualityModeLow 
  #SmoothingModeHighQuality   = #QualityModeHigh
  #SmoothingModeNone          = 3
  #SmoothingModeAntiAlias     = 4
  #SmoothingModeAntiAlias8x4  = #SmoothingModeAntiAlias
  #SmoothingModeAntiAlias8x8  = 5
EndEnumeration ;} 

Enumeration ;{ EncoderParameterValue
 #EncoderParameterValueTypeByte          = 1
 #EncoderParameterValueTypeASCII         = 2
 #EncoderParameterValueTypeShort         = 3
 #EncoderParameterValueTypeLong          = 4
 #EncoderParameterValueTypeRational      = 5
 #EncoderParameterValueTypeLongRange     = 6
 #EncoderParameterValueTypeUndefined     = 7
 #EncoderParameterValueTypeRationalRange = 8
 #EncoderParameterValueTypePointer       = 9
EndEnumeration ;}

DataSection ;{ GDI+ CLSID data

 ;CLSID for the relevant GDI+ encoder parameters
 
 clsid_EncoderQuality:
 
 Data.l $1D5BE4B5
 Data.w $FA4A, $452D
 Data.b $9C, $DD, $5D, $B3, $51, $05, $E7, $EB

 clsid_EncoderCompression:   
 
 Data.l $E09D739D
 Data.w $CCD4, $44EE
 Data.b $8E, $BA, $3F, $BF, $8B, $E4, $FC, $58

 clsid_EncoderColorDepth:   
 
 Data.l $66087055
 Data.w $AD66, $4C7C
 Data.b $9A, $18, $38, $A2, $31, $0B, $83, $37

EndDataSection ;}

;}

;{ STRUCTURES

Structure GdiplusStartupInput
 GdiPlusVersion.l
 *DebugEventCallback.DebugEventProc
 SuppressBackgroundThread.l
 SuppressExternalCodecs.l
EndStructure

Structure GdiplusStartupOutput 
 *NotificationHook.NotificationHookProc
 *NotificationUnhook.NotificationUnhookProc
EndStructure 

Structure ImageCodecInfo
 clsid.CLSID
 formatID.GUID
 *codecName             ; format unicode
 *dllName               ; format unicode
 *formatDescription     ; format unicode
 *filenameExtension     ; format unicode
 *mimeType              ; format unicode
 flags.l
 version.l
 sigCount.l
 sigSize.l
 *sigPattern
 *sigMask
EndStructure

Structure EncoderParameter
 Guid.GUID
 NumberOfValues.l
 Type.l
 *Value
EndStructure

Structure EncoderParameters
 Count.i
 Parameter.EncoderParameter[1]
EndStructure

;}

Import "gdiplus.lib" ;{ IMPORTS
 GdiplusStartup (*token, *input.GdiplusStartupInput, *output.GdiplusStartupOutput)
 GdiplusShutdown (token)
 GdipGetImageWidth (image, *width)
 GdipGetImageHeight (image, *height)
 GdipGetImagePixelFormat (image, *format) 
 GdipCreateBitmapFromFile (filename.p-unicode, *image)
 GdipCreateBitmapFromStream(stream.IStream, *image) 
 GdipGetImageGraphicsContext (image, *graphics)
 GdipCreateFromHDC (hDC, *gfx) 
 GdipDrawImageRectI (gfx, image, x, y, width, height)
 GdipDeleteGraphics (gfx)
 GdipDisposeImage (image)
 GdipSetSmoothingMode(gfx, mode) 
 GdipSetInterpolationMode(gfx, mode)
 GdipSaveImageToFile (image, filename.p-unicode, *clsidEncoder.CLSID, *encoderParams)  
 GdipCreateBitmapFromHBITMAP (bitmap, palette, *image)  
 GdipCreateHBITMAPFromBitmap (image, *bitmap, backcolor) 
 GdipGetImageEncodersSize (*numEncoders, *size)
 GdipGetImageEncoders (numEncoders, size, *encoders.ImageCodecInfo)  
 GdipGetImageThumbnail (image, thumbWidth, thumbHeight, *thumbImage, *callback, *callbackData)
 GdipSaveImageToStream (image, stream.IStream, *clsidEncoder.CLSID, *encoderParams)
 GdipGetImageRawFormat (image, *guid)
EndImport ;}

Macro GDIP_CHECK_RET (ret, label)
 If ret <> #GDIPLUS_OK : Goto label : EndIf
EndMacro

Macro GDIP_CHECK_HND (hnd, label)
 If hnd = 0: Goto label : EndIf
EndMacro

Macro GDIP_CHECK_MEM (ptr, label)
 If ptr = 0: Goto label : EndIf
EndMacro

Procedure.i GdiPlusGetEncoderClsid (Format$, *Clsid.CLSID)
 Protected *tImageCodecInfo.ImageCodecInfo, *buffer = 0
 Protected iNumEncoders, iSize, k
 Protected iRetVal
 
 iRetVal = GdipGetImageEncodersSize (@iNumEncoders, @iSize)
 GDIP_CHECK_RET (iRetVal, GdiPlusGetEncoderClsid_ERR)
  
 If (iSize = 0): : iRetVal = #GDIPLUS_ERROR: Goto GdiPlusGetEncoderClsid_ERR: EndIf
  
 *buffer = AllocateMemory(iSize)
   
 If *buffer = 0: iRetVal = #GDIPLUS_OUT_OF_MEMORY: Goto GdiPlusGetEncoderClsid_ERR: EndIf
  
 *tImageCodecInfo = *buffer 
  
 iRetVal = GdipGetImageEncoders (iNumEncoders, iSize, *tImageCodecInfo)
 GDIP_CHECK_RET (iRetVal, GdiPlusGetEncoderClsid_ERR)
 
 iRetVal = #GDIPLUS_ERROR
   
 For k = 1 To iNumEncoders        
    If Format$ = PeekS(*tImageCodecInfo\mimeType, -1, #PB_Unicode)
        CopyMemory(@*tImageCodecInfo\clsid, *Clsid, SizeOf(CLSID))
        FreeMemory(*buffer)
        ProcedureReturn #GDIPLUS_OK
    EndIf
    *tImageCodecInfo + SizeOf(ImageCodecInfo)
 Next

GdiPlusGetEncoderClsid_ERR:
 If *buffer : FreeMemory(*buffer) : EndIf
 ProcedureReturn iRetVal 
EndProcedure

Procedure.i GdiPlusInit(*GdiToken)
 Protected input.GdiplusStartupInput    
 input\GdiPlusVersion = 1  
 ProcedureReturn GdiplusStartup(*GdiToken, @input, #Null)
EndProcedure

Procedure.i GdiPlusLoadImage (*hGdiImage, FileName$)
 ProcedureReturn GdipCreateBitmapFromFile(FileName$, *hGdiImage)
EndProcedure

Procedure.i GdiPlusLoadImageFromStream (*StreamBuffer, iStreamSize, *hGdiImage)            
 Protected oStream.IStream, iBytesWritten
 Protected iRetVal
 
 iRetVal = CreateStreamOnHGlobal_(#Null, 1, @oStream)
 GDIP_CHECK_RET (iRetVal, GdiPlusLoadImageFromStream_STM)
 
 iRetVal = oStream\Write(*StreamBuffer, iStreamSize, @iBytesWritten)
 GDIP_CHECK_RET (iRetVal, GdiPlusLoadImageFromStream_STM)
 
 iRetVal = GdipCreateBitmapFromStream(oStream, *hGdiImage)
 GDIP_CHECK_RET (iRetVal, GdiPlusLoadImageFromStream_ERR)

 iRetVal = oStream\Release()
  
 ProcedureReturn #GDIPLUS_OK
 
GdiPlusLoadImageFromStream_STM:
 iRetVal = #GDIPLUS_WIN32_ERROR

GdiPlusLoadImageFromStream_ERR:
 ProcedureReturn iRetVal
EndProcedure

Procedure.i GdiPlusResizeImage (*hGdiImage.Integer, iWidth, iHeight, iInterpolationQuality = #InterpolationModeHighQuality, iSmoothQuality = #SmoothingModeHighQuality)
 Protected hDC, gfx, nImage, hGdiImageOut
 Protected iRetVal
 
 nImage = CreateImage(#PB_Any, iWidth, iHeight, 24)
 GDIP_CHECK_HND (nImage, GdiPlusResizeImage_MEM)
 
 hDC = StartDrawing(ImageOutput(nImage)) 
    GDIP_CHECK_HND (hDC, GdiPlusResizeImage_ERR)
    
    iRetVal = GdipCreateFromHDC(hDC, @gfx) 
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
    
    iRetVal = GdipSetInterpolationMode(gfx, iInterpolationQuality)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
    
    iRetVal = GdipSetSmoothingMode(gfx, iSmoothQuality)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
    
    iRetVal = GdipDrawImageRectI(gfx, *hGdiImage\i, -1, -1, iWidth + 1, iHeight + 1)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
 StopDrawing()
 
 iRetVal = GdipCreateBitmapFromHBITMAP(ImageID(nImage), 0, @hGdiImageOut) 
 GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
 
 iRetVal = GdipDeleteGraphics(gfx)
 GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
  
 FreeImage(nImage)
 
 iRetVal = GdipDisposeImage(*hGdiImage\i)
 GDIP_CHECK_RET (iRetVal, GdiPlusResizeImage_ERR)
  
 *hGdiImage\i = hGdiImageOut
 
 ProcedureReturn #GDIPLUS_OK

GdiPlusResizeImage_MEM: 
 iRetVal = #GDIPLUS_OUT_OF_MEMORY
    
GdiPlusResizeImage_ERR:
 If IsImage(nImage) : FreeImage(nImage) : EndIf
 ProcedureReturn iRetVal
EndProcedure

Procedure.i GdiPlusResizeImageToNew (hGdiImage, *hGdiImageOut, iWidth, iHeight, iInterpolationQuality = #InterpolationModeHighQuality, iSmoothQuality = #SmoothingModeHighQuality)
 Protected hDC, gfx, nImage
 Protected iRetVal 
 
 nImage = CreateImage(#PB_Any, iWidth, iHeight, 24)
 GDIP_CHECK_HND (nImage, GdiPlusResizeImageToNew_MEM)
 
 hDC = StartDrawing(ImageOutput(nImage)) 
    GDIP_CHECK_HND (hDC, GdiPlusResizeImageToNew_ERR)
    
    iRetVal = GdipCreateFromHDC(hDC, @gfx) 
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR)
    
    iRetVal = GdipSetInterpolationMode(gfx, iInterpolationQuality)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR)
    
    iRetVal = GdipSetSmoothingMode(gfx, iSmoothQuality)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR)
    
    iRetVal = GdipDrawImageRectI(gfx, hGdiImage, 0, 0, iWidth, iHeight)
    GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR) 
 StopDrawing()
 
 iRetVal = GdipCreateBitmapFromHBITMAP(ImageID(nImage), 0, *hGdiImageOut) 
 GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR)
 
 iRetVal = GdipDeleteGraphics(gfx)
 GDIP_CHECK_RET (iRetVal, GdiPlusResizeImageToNew_ERR)
 
 ProcedureReturn #GDIPLUS_OK
  
GdiPlusResizeImageToNew_MEM:
 iRetVal = #GDIPLUS_OUT_OF_MEMORY 
 
GdiPlusResizeImageToNew_ERR:   
 If IsImage(nImage) : FreeImage(nImage) : EndIf 
 ProcedureReturn iRetVal  
EndProcedure

Procedure.i GdiPlusChangeImageColorDepth (hCurrImage, *hNewImage, iColorDepth) 
 Protected hDC, gfx, nImage
 Protected iWidth, iHeight
 Protected iRetVal, flgDrawing = #False

 ; hCurrImage is automatically freed upon exit

 iRetVal = GdipGetImageWidth(hCurrImage, @iWidth)
 GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)
 
 iRetVal = GdipGetImageHeight(hCurrImage, @iHeight)
 GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)

 nImage = CreateImage (#PB_Any, iWidth, iHeight, iColorDepth)
 GDIP_CHECK_HND (nImage, GdiPlusChangeImageColorDepth_MEM)
  
 hDC = StartDrawing(ImageOutput(nImage)) 
    flgDrawing = #True
    
    GDIP_CHECK_HND (hDC, GdiPlusChangeImageColorDepth_HND)
     
    iRetVal = GdipCreateFromHDC(hDC, @gfx) 
    GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)
    
    iRetVal = GdipDrawImageRectI(gfx, hCurrImage, 0, 0, iWidth, iHeight)
    GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR) 
 StopDrawing()
 
 iRetVal = GdipDeleteGraphics(gfx)
 GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)
 
 iRetVal = GdipDisposeImage(hCurrImage)
 GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)
 
 iRetVal = GdipCreateBitmapFromHBITMAP(ImageID(nImage), 0, *hNewImage)
 GDIP_CHECK_RET (iRetVal, GdiPlusChangeImageColorDepth_ERR)

 FreeImage(nImage)
 
 ProcedureReturn #GDIPLUS_OK

GdiPlusChangeImageColorDepth_MEM:
 iRetVal = #GDIPLUS_OUT_OF_MEMORY
 Goto GdiPlusChangeImageColorDepth_ERR:
 
GdiPlusChangeImageColorDepth_HND:
 iRetVal = #GDIPLUS_ERROR 
 Goto GdiPlusChangeImageColorDepth_ERR:

GdiPlusChangeImageColorDepth_ERR:
 If IsImage(nImage) : FreeImage(nImage): EndIf 
 If (flgDrawing) : StopDrawing() : EndIf 
 ProcedureReturn iRetVal
EndProcedure

Procedure.i GdiPlusPbImageToImage (nPbImage, *hGdiImageOut)
 ProcedureReturn GdipCreateBitmapFromHBITMAP(ImageID(nPbImage), 0, *hGdiImageOut)
EndProcedure

Procedure.i GdiPlusImageToPbImage (hGdiImage, *nPbImageOut.Integer)
 Protected hDC, gfx, nImage
 Protected iWidth, iHeight
 Protected iRetVal
 
 iRetVal = GdipGetImageWidth(hGdiImage, @iWidth)
 GDIP_CHECK_RET (iRetVal, GdiPlusImageToPbImage_ERR)
 
 iRetVal = GdipGetImageHeight(hGdiImage, @iHeight)
 GDIP_CHECK_RET (iRetVal, GdiPlusImageToPbImage_ERR)
  
 nImage = CreateImage (#PB_Any, iWidth, iHeight, 24)
 GDIP_CHECK_HND (nImage, GdiPlusImageToPbImage_MEM)
  
 hDC = StartDrawing(ImageOutput(nImage))  
    GDIP_CHECK_HND (hDC, GdiPlusImageToPbImage_ERR)
     
    iRetVal = GdipCreateFromHDC(hDC, @gfx) 
    GDIP_CHECK_RET (iRetVal, GdiPlusImageToPbImage_ERR)
    
    iRetVal = GdipDrawImageRectI(gfx, hGdiImage, 0, 0, iWidth, iHeight)
    GDIP_CHECK_RET (iRetVal, GdiPlusImageToPbImage_ERR)
 StopDrawing()
  
 iRetVal = GdipDeleteGraphics(gfx) 
 GDIP_CHECK_RET (iRetVal, GdiPlusImageToPbImage_ERR)
 
 *nPbImageOut\i = nImage 
 ProcedureReturn #GDIPLUS_OK

GdiPlusImageToPbImage_MEM:
 iRetVal = #GDIPLUS_OUT_OF_MEMORY
  
GdiPlusImageToPbImage_ERR: 
 If IsImage(nImage) : FreeImage(nImage) : EndIf
 If hDC : StopDrawing() : EndIf
 ProcedureReturn iRetVal 
EndProcedure

Procedure.i GdiPlusSaveImageToJpgFile (hGdiImage, FileName$, iQuality = 100)
 Protected tEncoderCLSID.CLSID, tEncoderParameters.EncoderParameters
 Protected iRetVal

 iRetVal = GdiPlusGetEncoderClsid(#GDIPLUS_JPG_ENCODER, @tEncoderCLSID)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgFile_ERR)
 
 tEncoderParameters\Count = 1

 CopyMemory(?clsid_EncoderQuality, @tEncoderParameters\Parameter[0]\guid, SizeOf(GUID))

 ; compression options
 tEncoderParameters\Parameter[0]\Type = #EncoderParameterValueTypeLong
 tEncoderParameters\Parameter[0]\NumberOfValues = 1
 tEncoderParameters\Parameter[0]\Value = @iQuality        
  
 iRetVal = GdipSaveImageToFile(hGdiImage, FileName$, @tEncoderCLSID, @tEncoderParameters) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgFile_ERR)
 
 ProcedureReturn #GDIPLUS_OK

GdiPlusSaveImageToJpgFile_ERR: 
 ProcedureReturn iRetVal 
EndProcedure

Procedure.i GdiPlusSaveImageToPngFile (hGdiImage, FileName$, iColorDepth = 24)
 Protected tEncoderCLSID.CLSID, tEncoderParameters.EncoderParameters
 Protected iRetVal

 iRetVal = GdiPlusGetEncoderClsid(#GDIPLUS_PNG_ENCODER, @tEncoderCLSID)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngFile_ERR)
       
 tEncoderParameters\Count = 1

 CopyMemory(?clsid_EncoderColorDepth, @tEncoderParameters\Parameter[0]\guid, SizeOf(GUID))

 tEncoderParameters\Parameter[0]\Type = #EncoderParameterValueTypeLong
 tEncoderParameters\Parameter[0]\NumberOfValues = 1
 tEncoderParameters\Parameter[0]\Value = @iColorDepth        
  
 iRetVal = GdipSaveImageToFile(hGdiImage, FileName$, @tEncoderCLSID, @tEncoderParameters) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngFile_ERR)
  
 ProcedureReturn #GDIPLUS_OK

GdiPlusSaveImageToPngFile_ERR:
 ProcedureReturn iRetVal 
EndProcedure

Procedure.i GdiPlusSaveImageToJpgStream (hGdiImage, *StreamBuffer.Integer, iQuality = 100)            
 Protected tEncoderCLSID.CLSID, tEncoderParameters.EncoderParameters
 Protected oStream.IStream, StreamSize.q, iBytesRead
 Protected iRetVal

 iRetVal = GdiPlusGetEncoderClsid(#GDIPLUS_JPG_ENCODER, @tEncoderCLSID)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_ERR) 
      
 tEncoderParameters\Count = 1

 CopyMemory(?clsid_EncoderQuality, @tEncoderParameters\Parameter[0]\guid, SizeOf(GUID))

 ; compression options        
 tEncoderParameters\Parameter[0]\Type = #EncoderParameterValueTypeLong
 tEncoderParameters\Parameter[0]\NumberOfValues = 1
 tEncoderParameters\Parameter[0]\Value = @iQuality        
 
 iRetVal = CreateStreamOnHGlobal_(#Null, 1, @oStream)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_STM)
 
 iRetVal = GdipSaveImageToStream(hGdiImage, oStream, @tEncoderCLSID, @tEncoderParameters) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_ERR)
 
 iRetVal = oStream\Seek(0, #STREAM_SEEK_END, @StreamSize)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_STM)
 
 iRetVal = oStream\Seek(0, #STREAM_SEEK_SET, 0)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_STM)
 
 *StreamBuffer\i = AllocateMemory(StreamSize)
 GDIP_CHECK_MEM (*StreamBuffer\i, GdiPlusSaveImageToJpgStream_MEM)
     
 iRetVal = oStream\Read(*StreamBuffer\i, StreamSize, @iBytesRead)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToJpgStream_STM)
 
 oStream\Release()
 ProcedureReturn #GDIPLUS_OK

GdiPlusSaveImageToJpgStream_MEM:
 iRetVal = #GDIPLUS_OUT_OF_MEMORY
 Goto GdiPlusSaveImageToJpgStream_ERR:
 
GdiPlusSaveImageToJpgStream_STM:
 iRetVal = #GDIPLUS_WIN32_ERROR

GdiPlusSaveImageToJpgStream_ERR: 
 ProcedureReturn iRetVal 
EndProcedure

Procedure.i GdiPlusSaveImageToPngStream (hGdiImage, *StreamBuffer.Integer, iColorDepth = 24)             
 Protected tEncoderCLSID.CLSID, tEncoderParameters.EncoderParameters
 Protected oStream.IStream, StreamSize.q, iBytesRead
 Protected iRetVal

 iRetVal = GdiPlusGetEncoderClsid(#GDIPLUS_PNG_ENCODER, @tEncoderCLSID) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_ERR)
       
 tEncoderParameters\Count = 1

 CopyMemory(?clsid_EncoderColorDepth, @tEncoderParameters\Parameter[0]\guid, SizeOf(GUID))

 tEncoderParameters\Parameter[0]\Type = #EncoderParameterValueTypeLong
 tEncoderParameters\Parameter[0]\NumberOfValues = 1
 tEncoderParameters\Parameter[0]\Value = @iColorDepth        
    
 iRetVal = CreateStreamOnHGlobal_(#Null, 1, @oStream) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_STM)
 
 iRetVal = GdipSaveImageToStream(hGdiImage, oStream, @tEncoderCLSID, @tEncoderParameters) 
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_ERR)
 
 iRetVal = oStream\Seek(0, #STREAM_SEEK_END, @StreamSize)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_STM)
 
 iRetVal = oStream\Seek(0, #STREAM_SEEK_SET, 0)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_STM)
 
 *StreamBuffer\i = AllocateMemory(StreamSize)
 GDIP_CHECK_MEM (*StreamBuffer\i, GdiPlusSaveImageToPngStream_MEM)
 
 iRetVal = oStream\Read(*StreamBuffer\i, StreamSize, @iBytesRead)
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_STM)
 
 iRetVal = oStream\Release()
 GDIP_CHECK_RET (iRetVal, GdiPlusSaveImageToPngStream_STM)

 ProcedureReturn #GDIPLUS_OK

GdiPlusSaveImageToPngStream_MEM:
 iRetVal = #GDIPLUS_OUT_OF_MEMORY
 Goto GdiPlusSaveImageToPngStream_ERR:
 
GdiPlusSaveImageToPngStream_STM:
 iRetVal = #GDIPLUS_WIN32_ERROR

GdiPlusSaveImageToPngStream_ERR: 
 ProcedureReturn iRetVal 
EndProcedure

; IDE Options = PureBasic 5.73 LTS (Windows - x86)
; Folding = ------
; EnableXP
; EnableUser
; Executable = testgdi_puro.exe
; CPU = 1
; CompileSourceDirectory
; EnableBuildCount = 4