CompilerIf (#PB_Compiler_OS = #PB_OS_Windows)
#PATH_DELIMITER$ = "\"
CompilerElse
#PATH_DELIMITER$ = "/"
CompilerEndIf

Enumeration 
#RET_OK = 1
 
#ERR_INVALID_PARAMETERS            
#ERR_CALL_FAILED           
#ERR_OUT_OF_MEMORY          
#ERR_ALREADY_CALLED
#ERR_NOT_FOUND  
#ERR_USER_ABORT
#ERR_OS_NOT_SUPPORTED        

#ERR_FILE_IO
#ERR_FILE_CREATION
#ERR_FILE_OPENING
#ERR_FILE_NOT_FOUND
EndEnumeration

Enumeration 
#K_SCROLL_DOWN   
#K_SCROLL_UP    
#K_SPLIT_KEEP_DELIMITER 
EndEnumeration

Enumeration
#DWMWA_NCRENDERING_ENABLED = 1
#DWMWA_NCRENDERING_POLICY
#DWMWA_TRANSITIONS_FORCEDISABLED
#DWMWA_ALLOW_NCPAINT
#DWMWA_CAPTION_BUTTON_BOUNDS
#DWMWA_NONCLIENT_RTL_LAYOUT
#DWMWA_FORCE_ICONIC_REPRESENTATION
#DWMWA_FLIP3D_POLICY
#DWMWA_EXTENDED_FRAME_BOUNDS
#DWMWA_HAS_ICONIC_BITMAP
#DWMWA_DISALLOW_PEEK
#DWMWA_EXCLUDED_FROM_PEEK
#DWMWA_LAST
EndEnumeration

Structure T_WINDOW_REQUESTER_POSITION
 X.i
 Y.i
 Hook.i
 Window.i
 *fpCallBack 
EndStructure: Define G_RequesterPosition.T_WINDOW_REQUESTER_POSITION

Structure T_WINDOW_RECT
; DESC
; 	Used by GetWindowBoundRect(), CenterWindowToWindow(), CenterWindowToDesktop()

 X.i    ; X coordinate of the top left corner of the window
 Y.i    ; Y coordinate of the top left corner of the window
 W.i    ; Width of the window
 H.i    ; Height of the window
EndStructure

Declare.s 	FormatQuadHelp (qValue.q, ThousSep$ , Reserved1$ = "", Reserved2$ = "", iReserved3 = 0)
Declare.s 	FormatDoubleHelp (dValue.d, iDecimals, ThousSep$, DecSep$, Reserved1$ = "", Reserved2$ = "", iReserved3 = 0)
Declare 	CallBack_RequesterPosition (hWin, MSG, wParam, iParam)
Declare 	Hook_RequesterPosition (idHook, wParam, iParam)
Declare.i 	IsThemeActive()
Declare.i 	IsAeroActive()
Declare.i 	IIF (exp, iTrue, iFalse)
Declare.s 	IIFs (exp, True$, False$)
Declare.s 	GetSystemDecimalSep ()
Declare.s 	GetSystemDateSep ()
Declare.s 	GetSystemDateFormat ()
Declare.s 	FormatDouble (dValue.d, iDecimals = 2, ThousSep$ = "", DecSep$ = "")
Declare.s 	FormatQuad (qValue.q, ThousSep$ = "")
Declare 	FreeString (*StringAddress)
Declare.s 	GetSystemThousandSep ()
Declare.s 	GetSystemTimeZone (*flgDST.Integer, *iMinutesOffset.Integer)
Declare.i 	FindTopLevelWindowByName (WinName$, WinClass$ = "")
Declare.i 	CheckSingleInstanceEx (WinName$, flgBringToFocus = #True, WinClass$ = "WindowClass_", MutexName$ = "pbmutex_single_instance")
Declare 	CalcRectPosToRectCenter (*tWinChild.T_WINDOW_RECT, *tWinParent.T_WINDOW_RECT)
Declare 	CenterRequesterPositionToWindow (hWnd)
Declare 	GetWindowBoundRect (hWnd, *tWinBound.T_WINDOW_RECT)
Declare 	Gadget_GetStringSize (nWindow, nGadget, Text$, *tSize.SIZE)
Declare 	ListIconGadget_Scroll (nGadget, iDirection)
Declare.i 	GetDesktopWidth()
Declare.i 	GetDesktopHeight()
Declare.i 	ListIconGadget_GetHeaderHeight (nGadget)
Declare.i 	IsScrollBarVisible (hWnd, iScrollStyle)
Declare.s 	FormatQuadWithByteSuffix (qValue.q, flgLongPrefix = #False, iDecimals = 2, ThousSep$ = "", DecSep$ = "")
Declare 	CenterWindowToWindow (hWndChild, hWndParent, flgShow = #True)
Declare.i 	ListWriteToTextFile (nFileNum, List TextFile$(), *iBytesWritten.Integer, Term$ = #CRLF$)
Declare.i 	GetFreePhysicalMemory (*qMemoryFree.Quad)
Declare.i 	ReadPreferenceIntegerEx (Keyword$, iDefaultValue, iMin, iMax)
Declare.s 	FixPathEndChar (Path$)
Declare 	IsDirThere (Path$)
Declare.i 	SetWindowTheme (hWnd, SubAppName$, SubIdList$)
Declare 	StringGadget_SetLimit (nGadget, iSize)
Declare.s 	GetSpecialFolderLocation (iCSIDL)
Declare.s 	GetDesktopPath()
Declare.s 	Control_GetFontName (hWnd)
Declare.i 	Control_GetFontSize (hWnd)
Declare.i 	EmptyWorkingSet (hProcess)
Declare 	CenterWindowToDesktop (hWndChild, flgShow = #True)
Declare 	ListIconGadget_SetColumnAlignment (nGadget, iCol, iAlign)
Declare 	SubclassWindow (hWnd, *fpNewWinProc, PropID$ = "oldWinProc")
Declare.i 	SplitStringToWords (Buff$, Delimiters$, List Words$(), iFlags = #Null)
Declare 	FreeImageEx (nImage)

Macro LOWORD (word) 
; Get the low byte (8 bit) of a word (16 bit).
 (word & $FFFF)
EndMacro

Macro HIWORD (word) 
; Get the high byte (8 bit) of a word (16 bit),
 ((word >> 16) & $FFFF)
EndMacro

Macro LODWORD (dword)
; Get the low word (16 bit) of a 32 bit word.
 (dword & $FFFF)
EndMacro

Macro HIDWORD (dword)
; Get the high word (16 bit) of a 32 bit word.
 (dword >> 16)
EndMacro

Procedure.s FormatQuadHelp (qValue.q, ThousSep$ , Reserved1$ = "", Reserved2$ = "", iReserved3 = 0)
 ; called by FormatQuad()
 
 If Not iReserved3
    ProcedureReturn FormatQuadHelp (0, ThousSep$, Str(qValue), "", 1)
 EndIf
 If Reserved1$ = "" Or Reserved1$ = "-"
    ProcedureReturn Reserved1$ + Reserved2$
 EndIf
 If iReserved3 = 2
    Reserved2$ = ThousSep$ + Reserved2$
 EndIf
 ProcedureReturn FormatQuadHelp (0, ThousSep$, Left(Reserved1$, Len(Reserved1$) - 3), Right(Reserved1$, 3) + Reserved2$, 2)
EndProcedure

Procedure.s FormatDoubleHelp (dValue.d, iDecimals, ThousSep$, DecSep$, Reserved1$ = "", Reserved2$ = "", iReserved3 = 0) 
 ; called by FormatDouble()
 
 If Not iReserved3    
    ProcedureReturn FormatDoubleHelp (0, 0, ThousSep$, DecSep$, StringField(StrD(dValue), 1, "."),  DecSep$ + Left(StringField(StrD(dValue), 2, "."), iDecimals), 1)
 EndIf
 If Reserved1$ = "" Or Reserved1$ = "-"
    ProcedureReturn Reserved1$ + Reserved2$
 EndIf
 If iReserved3 = 2
    Reserved2$ = ThousSep$ + Reserved2$
 EndIf
 ProcedureReturn FormatDoubleHelp (0, 0, ThousSep$, DecSep$, Left(Reserved1$, Len(Reserved1$) - 3), Right(Reserved1$, 3) + Reserved2$, 2)
EndProcedure

Procedure CallBack_RequesterPosition (hWin, MSG, wParam, iParam) 
 ; called by Hook_RequesterPosition()
 
 Shared G_RequesterPosition.T_WINDOW_REQUESTER_POSITION   
 
 Protected tWinChild.T_WINDOW_RECT, tWinParent.T_WINDOW_RECT
   
 Select MSG
    Case #WM_DESTROY
        ; close fake window if necessary
        If G_RequesterPosition\Window
            CloseWindow(G_RequesterPosition\Window)
            G_RequesterPosition\Window = #Null
        EndIf
         
        ; restore requester callback
        SetWindowLongPtr_(hWin, #GWL_WNDPROC, G_RequesterPosition\fpCallBack)
                  
    Case #WM_INITDIALOG
        If (G_RequesterPosition\X = #PB_Ignore) And (G_RequesterPosition\Y = #PB_Ignore) ; centering requested
            
            GetWindowBoundRect(G_RequesterPosition\Window, @tWinParent)                   
            
            GetWindowBoundRect(hWin, @tWinChild)
                        
            CalcRectPosToRectCenter(@tWinChild, @tWinParent)
            
            G_RequesterPosition\X = IIF(Bool(tWinChild\X > 0), tWinChild\X, 0)
            G_RequesterPosition\Y = IIF(Bool(tWinChild\Y > 0), tWinChild\Y, 0)
            
            G_RequesterPosition\Window = 0
        EndIf
    
        ; update requester position
        SetWindowPos_(hWin, 0, G_RequesterPosition\X, G_RequesterPosition\Y, 0, 0, #SWP_NOSIZE | #SWP_NOACTIVATE)

 EndSelect
   
 ProcedureReturn CallWindowProc_ (G_RequesterPosition\fpCallBack, hWin, MSG, wParam, iParam)
EndProcedure

Procedure Hook_RequesterPosition (idHook, wParam, iParam)

 ; called by SetRequesterPosition(), CenterRequesterPositionToWindow()
 
 Shared G_RequesterPosition.T_WINDOW_REQUESTER_POSITION
 
 Protected WinClass$ = Space(255)
 Protected *RequesterPositionCWP.CWPSTRUCT = iParam
 Protected iMessage = *RequesterPositionCWP\Message
 Protected hWin = *RequesterPositionCWP\hwnd
 Protected iRetVal
   
 ; special case for InputRequester
 
 GetClassName_ (hWin, WinClass$, 255)
 
 If LCase(WinClass$) = "inputrequester" : iMessage = #WM_INITDIALOG : EndIf
   
 Select iMessage 
    Case #WM_INITDIALOG
        ; modify Requester callback
        G_RequesterPosition\fpCallBack = SetWindowLongPtr_(hWin, #GWL_WNDPROC, @CallBack_RequesterPosition())
             
        ; restore parent HOOK
        iRetVal = CallNextHookEx_(G_RequesterPosition\Hook, idHook, wParam, iParam)
        UnhookWindowsHookEx_(G_RequesterPosition\Hook)
        G_RequesterPosition\Hook = #Null
         
    Default
        iRetVal = CallNextHookEx_(G_RequesterPosition\Hook, idHook, wParam, iParam)
 EndSelect
   
 ProcedureReturn iRetVal
 
EndProcedure

Procedure.i IsThemeActive()
; Do not call this function during DllMain or global objects contructors.

Protected *IsThemeActive
Protected iRetVal = 0 ; Themes not active
Protected hDll

If OSVersion() >= #PB_OS_Windows_XP
    hDll = OpenLibrary(#PB_Any, "UxTheme.dll")
    If hDll
        *IsThemeActive = GetFunction(hDll, "IsThemeActive")
        If *IsThemeActive
            iRetVal = CallFunctionFast(*IsThemeActive) ; #True / #False
        EndIf   
        CloseLibrary(hDll)
    EndIf   
EndIf

ProcedureReturn iRetVal
EndProcedure

Procedure.i IsAeroActive()
Protected *DwmIsCompositionEnabled
Protected iRetVal = 0 ; Aero is not active
Protected hDll
Protected flgBool

If OSVersion() >= #PB_OS_Windows_Vista
    hDll = OpenLibrary(#PB_Any, "dwmapi.dll")
    If hDll
        *DwmIsCompositionEnabled = GetFunction(hDll, "DwmIsCompositionEnabled")

        If *DwmIsCompositionEnabled
            If CallFunctionFast(*DwmIsCompositionEnabled, @flgBool)  = #S_OK
                iRetVal = flgBool ; #True / #False
            EndIf       
        EndIf
        CloseLibrary(hDll)
    EndIf
EndIf

ProcedureReturn  iRetVal
EndProcedure

Procedure.i IIF (exp, iTrue, iFalse)
 If (exp)
    ProcedureReturn iTrue
 EndIf    
 
 ProcedureReturn iFalse 
EndProcedure

Procedure.s IIFs (exp, True$, False$)
 If (exp)
    ProcedureReturn True$
 EndIf
 
 ProcedureReturn False$ 
EndProcedure

Procedure.s GetSystemDecimalSep ()

; DESC
; 	Get the character defined in the control panel as decimal separator.

 Protected iBufsize = GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_SDECIMAL, #Null, 0)
 Protected Buff$ = Space(iBufsize)
 
 If GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_SDECIMAL, @Buff$, iBufsize)
    ProcedureReturn Buff$
 EndIf
 
 ProcedureReturn "."
EndProcedure

Procedure.s GetSystemDateSep ()

; DESC
; 	Get the character defined in the control panel as date separator.

 Protected iBufsize = GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_SDATE, #Null, 0)
 Protected Buff$ = Space(iBufsize)
  
 If GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_SDATE, @Buff$, iBufsize)
    ProcedureReturn Buff$
 EndIf
 
 ProcedureReturn "/" 
EndProcedure


Procedure.s GetSystemDateFormat ()

; DESC
; 	Get the dd,mm,yy character sequence order as defined in the control panel.
;
; RET
;  The string mask usable by the PB's FormatDate() function.

 Protected iBufsize = GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_IDATE, #Null, 0)
 Protected Buff$ = Space(iBufsize)
 Protected DateSep$ = GetSystemDateSep()
 Protected RetVal$
  
 If GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_IDATE, @Buff$, iBufsize)
    Select Buff$
        Case "0"
            RetVal$ = "%mm" + DateSep$ + "%dd" + DateSep$ + "%yy"
        Case "1"
            RetVal$ = "%dd" + DateSep$ + "%mm" + DateSep$ + "%yy"   
        Case "2"
            RetVal$ = "%yy" + DateSep$ + "%mm" + DateSep$ + "%dd"
    EndSelect
    
    ProcedureReturn RetVal$ 
 EndIf
 
 ProcedureReturn "%dd/%mm/%yy"
EndProcedure

Procedure.s FormatDouble (dValue.d, iDecimals = 2, ThousSep$ = "", DecSep$ = "")

; DESC
; 	Will format the passed double value using the specified thousands and decimal separator.
;
; IN
;  dValue      ; The double value to be formatted.
;  iDecimals   ; The number of decimal digits (defaults to 2).
;  ThousSep$   ; The char to use as thousands separator (defaults to system settings).
;  DecSep$     ; The char to use as decimal separator (defaults to system settings).
;
; RET
;  The formatted number as a string.
;
; EXAMPLE
;  Debug FormatDouble(1500.3257, 3) ; output = 1,500.326
;  Debug FormatDouble(10.128) ; output = 10.13
;  Debug FormatDouble(100.7, 2) ; output = 100,70
 
 Protected RetVal$
   
 If Len(ThousSep$) = 0 : ThousSep$ = GetSystemThousandSep(): EndIf
 If Len(DecSep$) = 0 : DecSep$ = GetSystemDecimalSep(): EndIf
 
 RetVal$ = FormatDoubleHelp (dValue, iDecimals, ThousSep$, DecSep$)
 
 If Right(RetVal$, 1) = DecSep$
    RetVal$ = Left(RetVal$, Len(RetVal$) - 1)
 EndIf

 ProcedureReturn RetVal$
EndProcedure

Procedure.s FormatQuad (qValue.q, ThousSep$ = "")

; DESC
; 	Will format the passed quad value using the specified thousands separator.
;
; IN
; 	qValue      ; The quad value to be formatted.
;  ThousSep$   ; The char to use as thousands separator (defaults to system settings).
;
; RET
;  The formatted number as a string.
 
 If Len(ThousSep$) = 0 : ThousSep$ = GetSystemThousandSep(): EndIf
 
 ProcedureReturn FormatQuadHelp (qValue, ThousSep$)
EndProcedure


Procedure FreeString (*StringAddress)

; DESC
;  Deallocate the PB string passed as parameter. 
;  This procedures is useful to avoid memory leaks when you dinamically allocate a structure with a dinamic string inside. 
;  When you deallocate the space reserved for the structure, you need to deallocate any dinamic string field before that, 
;  or its memory will not be released.
;
; IN
; 	*StringAddress  ; Pointer to the PB dynamic string you want to deallocate.
;
; NOTES
;  From an idea of Freak.
;  http://www.purebasic.fr/english/viewtopic.php?p=156449&sid=87d7d8f256a347e374b35239b1f0798b#156449
;
; EXAMPLE
;	FreeString (@*MyStruct\sVarString)
 
 Protected String.String ; the String structure contains one String element, which is initialized to #Null on procedure start
 
 PokeI (@String, *StringAddress) ; we poke our string address into the structure
 
 ; when exiting, the PB's string free routine for the local structure will actually free the passed string
 
EndProcedure   

Procedure.s GetSystemThousandSep ()

; DESC
; 	Get the character defined in the control panel as thousands separator.
;
; RET
;  The thousand separator character.

 Protected iBufsize = GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_STHOUSAND, #Null, 0)
 Protected Buff$ = Space(iBufsize)
  
 If GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_STHOUSAND, @Buff$, iBufsize)
    ProcedureReturn Buff$
 EndIf
 
 ProcedureReturn "," 
EndProcedure


Procedure.s GetSystemTimeZone (*flgDST.Integer, *iMinutesOffset.Integer)

; DESC
; 	Get the DAY SAVING TIME status for the system and the time offset in minutes relative to the GMT zone.
;
; OUT
;  *flgDST         ; A pointer to an integer that will contain 1 if DST is active, else 0.
;  *iMinutesOffset ; A pointer to an integer that will contain the algebric offset relative to the GMT zone in minutes.
; 
; RET
;  A string representing the GMT offset of the system zone (i.e. "GTM +1.00") or "" if failed.

 Protected tTZI.TIME_ZONE_INFORMATION
 Protected GMT$
  
 Select GetTimeZoneInformation_(@tTZI)
    Case #TIME_ZONE_ID_STANDARD	
        *flgDST\i = 0
    Case #TIME_ZONE_ID_DAYLIGHT        
        *flgDST\i = 1
    Default
        ProcedureReturn ""
 EndSelect
 
 If tTZI\Bias >= 0
    GMT$ = "GMT "
 Else
    GMT$ = "GMT +"    
 EndIf

 *iMinutesOffset\i = tTZI\Bias
 
 ProcedureReturn GMT$ + StrF(- tTZI\Bias / 60.0, 2)
EndProcedure

Procedure.i FindTopLevelWindowByName (WinName$, WinClass$ = "")

; DESC
; 	Find a top level window from all the desktop childs whose name contains WinName$.
;
; IN
;  WinName$    ; The string that must be contained in the window's title.
;  WinClass$   ; The string that must be contained in the window's class name (if this parameter is empty no check on the class name is made).
; 	
; RET
;  The handle of the window or #Null if not found.
;
; NOTES
;  If the passed WinName$ is "My test" and there is a top level window with "My test window" in the title bar, the procedure will return its handle.
;
; OS
;  Windows

 Protected hChildWin = GetWindow_(GetDesktopWindow_(), #GW_CHILD)
 Protected CurrWinName$, CurrWinClass$
  
 If hChildWin 
    Repeat
        CurrWinName$ = Space(512)     
        CurrWinClass$ = Space(512)
        If GetWindowText_ (hChildWin, CurrWinName$, 511)
            GetClassName_(hChildWin, @CurrWinClass$, 511)
            If FindString(CurrWinClass$, WinClass$, 1) > 0 Or Len(WinClass$) = 0
                If FindString(CurrWinName$, WinName$, 1) > 0 And IsWindowVisible_(hChildWin) = #True                
                    ProcedureReturn hChildWin
                EndIf            
            EndIf    
        EndIf
        hChildWin = GetWindow_(hChildWin, #GW_HWNDNEXT)       
     Until hChildWin = 0 
 EndIf
 
 ProcedureReturn #Null
EndProcedure

Procedure.i CheckSingleInstanceEx (WinName$, flgBringToFocus = #True, WinClass$ = "WindowClass_", MutexName$ = "pbmutex_single_instance")

; DESC
; 	Check if this is the first instance of the current process by looking if a mutex is already defined.
;  If the mutex is present it assumes another copy of the process is already running and send some messages to bring its main window to focus. 
;  If the mutex is not present creates it and return.
;
; IN
;  WinName$        ; The name of the main window (or part of it if you are looking for a partial match).
;  flgBringToFocus ; If #True brings the program's main window to focus if a previous instance is found.
;  WinClass$       ; The window class of the main window (see the NOTES).
;  MutexName$      ; The name of the mutex (see the NOTES).
;
; RET
;  #True if this is the first instance, or #False if it is not.
;
; EXAMPLE
;  If CheckSingleInstance("Title of the main window") = #False
;      End
;  EndIf
; 
; NOTES
;  Usually you want to end the program if the return value is #False.
;  The "WindowClass_" string is the base name used by PB to number its windows, change this only if really needed.
;  The "pbmutex_single_instance" string is merged with WinName$ to create a suitable mutex name, normally you don't need to change this default.
;
; OS
;  Windows

 Protected hMutex, hWnd
 
 MutexName$ + "_" + WinName$
 
 hMutex = CreateMutex_(0, 0, @MutexName$)
 
 If GetLastError_() = #ERROR_ALREADY_EXISTS
    hWnd = FindTopLevelWindowByName (WinName$, WinClass$)
    If hWnd <> 0 And flgBringToFocus
        SendMessage_(hWnd, #SW_SHOWNORMAL, 0, 0)
        ShowWindow_(hWnd, #SW_RESTORE)
        ShowWindow_(hWnd, #SW_SHOW)
        SetForegroundWindow_(hWnd)
    EndIf
    
    ProcedureReturn #False
 EndIf
 
 ; the mutex will be released by the OS at the process exit
 
 ProcedureReturn #True
EndProcedure

Procedure CalcRectPosToRectCenter (*tWinChild.T_WINDOW_RECT, *tWinParent.T_WINDOW_RECT)

; DESC
; 	Update the X,Y fields of the *tWinChild child rect structure to center it to the parent window.
;
; IN
;  *tWinChild ; A pointer to a T_WINDOW_RECT structure containing the size of the child window (position will be overwrite).
;  *tWinParent; A pointer to a T_WINDOW_RECT structure containing the position and size of the parent window.
; 
; OUT
; 	*tWinChild ; The X,Y fields will contains the calculated values.
; 	 
; SEE
;  T_WINDOW_RECT
;
; NOTE
;  Can be used to calculate the centering coordinates of any window-like rectangular object to another.
  
 ; return the updated X,Y top coordinates for the child window
 
 *tWinChild\X = *tWinParent\X + ((*tWinParent\W - *tWinChild\W) / 2)
 *tWinChild\Y = *tWinParent\Y + ((*tWinParent\H - *tWinChild\H) / 2) 
EndProcedure


Procedure CenterRequesterPositionToWindow (hWnd)

; DESC
; 	Set the position for the requester you will open after this call so that it will be centered to the specified window.
;
; IN
;  hWnd    ; Handle of the window
;
; OS
;  Windows

 Shared G_RequesterPosition.T_WINDOW_REQUESTER_POSITION
 
 G_RequesterPosition\Window = hWnd
 G_RequesterPosition\X = #PB_Ignore
 G_RequesterPosition\Y = #PB_Ignore
 
 ; modify parent hook
 G_RequesterPosition\Hook = SetWindowsHookEx_(#WH_CALLWNDPROC, @Hook_RequesterPosition(), GetModuleHandle_(#Null), GetWindowThreadProcessId_(hWnd, #Null))
  
EndProcedure

Procedure GetWindowBoundRect (hWnd, *tWinBound.T_WINDOW_RECT)

; DESC
; 	Retrieves the dimensions of the bounding rectangle for the specified window.
;
; IN
;  hWnd ; Handle of the window.
;
; OUT
;  *tWinBound  ; A pointer to a T_WINDOW_RECT structure that will contain the bounding rectangle top corner coordinates and its size.
;
; SEE
;  T_WINDOW_RECT
;
; OS
;  Windows

 Protected tRECT.RECT
 
 GetWindowRect_(hWnd, @tRECT)
 
 *tWinBound\X = tRect\left
 *tWinBound\Y = tRect\top
 *tWinBound\W = tRect\right - tRect\left
 *tWinBound\H = tRect\bottom - tRect\top
EndProcedure

Procedure Gadget_GetStringSize (nWindow, nGadget, Text$, *tSize.SIZE)

; DESC
; 	Get the width and height that would be used by the string Text$ in the nGadget gadget.
;
; IN
;  nWindow ; The number of the PB window containing the gadget.
;  nGadget ; The number of the gadget.
;  Text$   ; The text string to be measured.
; 	 
; OUT
;  *tSize  ; Pointer to the SIZE structure that will contain heigth and width for the string in pixels.

 StartDrawing(WindowOutput(nWindow))
    DrawingFont(GetGadgetFont(nGadget))
    *tSize\cx = TextWidth(Text$)
    *tSize\cy = TextHeight(Text$) 
 StopDrawing()
 
EndProcedure

Procedure ListIconGadget_Scroll (nGadget, iDirection)

; DESC
; 	Scroll the contents ListIconGadget nGadget one row to the specified direction.
;
; IN
;  nGadget     ; ListIconGadget number.
;  iDirection  ; #K_SCROLL_DOWN, #K_SCROLL_UP
;
; NOTES
;  If there are not enough items in the gadget to fill the window the scroll is not performed.
;
; OS
;  Windows
 
 Protected iTop, iBottom
 Protected hListView = GadgetID(nGadget)
 
 If iDirection = #K_SCROLL_DOWN
    iBottom = SendMessage_(hListView, #LVM_GETTOPINDEX, #Null, #Null ) + SendMessage_(hListView, #LVM_GETCOUNTPERPAGE, #Null, #Null)

    If iBottom <= CountGadgetItems(nGadget) 
        ; scroll down                
        SendMessage_(hListView, #LVM_ENSUREVISIBLE, iBottom, #False)                
    EndIf
 EndIf 
 
 If iDirection = #K_SCROLL_UP   
    iTop = SendMessage_(hListView, #LVM_GETTOPINDEX, #Null, #Null)

    If iTop  
        ; scroll up                
        SendMessage_(hListView, #LVM_ENSUREVISIBLE, iTop - 1, #False)
    EndIf
 EndIf
  
EndProcedure

Procedure.i GetDesktopWidth()

; DESC
; 	Returns the desktop width in pixels.
;
; RET
;  The desktop width in pixels, 0 in case of error.

 If ExamineDesktops()
    ProcedureReturn DesktopWidth(0)
 EndIf 
 
 ProcedureReturn 0
EndProcedure

Procedure.i GetDesktopHeight()

; DESC
; 	Returns the desktop height in pixels.
;
; RET
;  The desktop height in pixels, 0 in case of error.

 If ExamineDesktops()
    ProcedureReturn DesktopHeight(0)
 EndIf 
 
 ProcedureReturn 0
EndProcedure

Procedure.i ListIconGadget_GetHeaderHeight (nGadget)

; DESC
; 	Return the ListIconGadget header height in pixels.
;
; IN
;  nGadget     ; ListIconGadget number.
;
; RET
;  The header height in pixels.
;
; OS
;  Windows

 Protected tRECT.RECT
 
 GetWindowRect_(SendMessage_(GadgetID(nGadget), #LVM_GETHEADER, #Null, #Null), @tRECT) 
 
 ProcedureReturn (tRECT\bottom - tRECT\top)
EndProcedure


Procedure.i IsScrollBarVisible (hWnd, iScrollStyle)

; DESC
; 	Return the specified scroll bar visibility status for the passed window.
;
; IN
;  hWnd            ; Handle of the window.
;  iScrollStyle    ; #WS_VSCROLL, vertical scroll bar 
;                  ; #WS_HSCROLL, horizontal scroll bar 
;
; RET
;  #True if it is visible, else #False.
;
; OS
;  Windows

 If (GetWindowLongPtr_(hWnd, #GWL_STYLE) & iScrollStyle)
    ProcedureReturn #True
 EndIf
 
 ProcedureReturn #False
 
EndProcedure

Procedure.s FormatQuadWithByteSuffix (qValue.q, flgLongPrefix = #False, iDecimals = 2, ThousSep$ = "", DecSep$ = "")

; DESC
; 	Will format the passed quad value using the specified thousands and decimal separator and appending the appropriate prefix used for memory quantities.
;
; IN
;  qValue          ; The quad value to be formatted.
;  flgLongPrefix   ; If #True the long version of the prefix will be used, else the short one.
;  iDecimals       ; The number of decimal digits (defaults to 2).
;  ThousSep$       ; The char to use as thousands separator (defaults to system settings).
;  DecSep$         ; The char to use as decimal separator (defaults to system settings).
;
; RET
;  The formatted number as a string.
;
; EXAMPLE
;  Debug FormatQuadWithByteSuffix(123456) ; output = 120.56 KB
;  Debug FormatQuadWithByteSuffix(123456, #True) ; output = 120.56 Kilobytes
;  Debug FormatQuadWithByteSuffix(123456789) ; output = 117.74 MB
 
 Protected RetVal$, Unit$
 Protected dReduced.d
 Protected iCount
 
 If Len(ThousSep$) = 0 : ThousSep$ = GetSystemThousandSep(): EndIf
 If Len(DecSep$) = 0 : DecSep$ = GetSystemDecimalSep(): EndIf

 dReduced = qValue
 
 While dReduced >= 1024
    dReduced = dReduced / 1024 
    iCount + 1     
 Wend

 Select iCount
    Case 0
        Unit$ = ""
    Case 1    
        Unit$ = IIFs(flgLongPrefix, "Kilobytes", "KB")
    Case 2
        Unit$ = IIFs(flgLongPrefix, "Megabytes", "MB")
    Case 3
        Unit$ = IIFs(flgLongPrefix, "Gigabytes", "GB")
    Case 4
        Unit$ = IIFs(flgLongPrefix, "Terabytes", "TB")
    Case 5
        Unit$ = IIFs(flgLongPrefix, "Petabytes", "PB")
    Default
        ; WHAT ?!?       
        ProcedureReturn "Overflow"
 EndSelect

 RetVal$ = FormatDouble(dReduced, iDecimals, ThousSep$, DecSep$)
 
 If Right(RetVal$, iDecimals + 1) = LSet(DecSep$, iDecimals + 1, "0")
    RetVal$ = Left(RetVal$, Len(RetVal$) - (iDecimals + 1))
 EndIf
 
 If Right(RetVal$, 1) = DecSep$
    RetVal$ = Left(RetVal$, Len(RetVal$) - 1)
 EndIf

 RetVal$ + " " + Unit$
 
 ProcedureReturn RetVal$

EndProcedure

Procedure CenterWindowToWindow (hWndChild, hWndParent, flgShow = #True)

; DESC
; 	Center the child window to the parent window.
;
; IN
;  hWndChild   ; Handle of the child window to be centered
;  hWndParent  ; Handle of the parent window 
;  flgShow     ; True if the window must be made visible after centering it
; 
; NOTE
;  Usually you will create the child window invisible, then call this procedure without specifying the flgShow parameter.
;  So the procedure will center the child window to the parent and it will make it visible automatically.
;
; OS
;  Windows

 Protected tWinChild.T_WINDOW_RECT, tWinParent.T_WINDOW_RECT
 Protected iFlags = #SWP_NOSIZE | #SWP_NOZORDER 

 GetWindowBoundRect (hWndChild, @tWinChild)
 
 GetWindowBoundRect (hWndParent, @tWinParent)
 
 CalcRectPosToRectCenter(@tWinChild, @tWinParent)
 
 If tWinChild\X < 0 : tWinChild\X = 0 : EndIf 
 If tWinChild\Y < 0 : tWinChild\Y = 0 : EndIf
 
 If flgShow 
    iFlags | #SWP_SHOWWINDOW	
 EndIf
 
 SetWindowPos_(hWndChild, 0, tWinChild\X, tWinChild\Y, 0, 0, iFlags)
EndProcedure


Procedure.i ListWriteToTextFile (nFileNum, List TextFile$(), *iBytesWritten.Integer, Term$ = #CRLF$) 

; DESC
; 	Write a text file from memory reading it from a linked list, one line for item.
;
; IN
; 	nFileNum	    ; The handle of the file already opened for write.
; 	TextFile$()     ; The linked list of strings from where the lines of text will be taken.
;  Term$           ; A string containing the chars to be used to indicate the end of line (default to CR + LF)
;
; OUT
;  *iBytesWritten  ; Pointer to an integer which will contain the total number of bytes written
;
; RET
;  #RET_OK
;  #ERR_INVALID_PARAMETERS
;  #ERR_FILE_IO
;
; NOTES
;  The file is not closed on exit.

 
 Protected iCount, iTermLen = Len(Term$)
 
 If IsFile(nFileNum)
    ResetList(TextFile$())
    
    While NextElement(TextFile$())
        WriteString (nFileNum, TextFile$() + Term$)
        iCount + Len(TextFile$()) + iTermLen ; include CR + LF
    Wend
 Else
    ProcedureReturn #ERR_INVALID_PARAMETERS
 EndIf  
 
 FlushFileBuffers(nFileNum)
 
 If Lof(nFileNum) <> iCount
    *iBytesWritten\i = 0
    ProcedureReturn #ERR_FILE_IO    
 EndIf
 
 *iBytesWritten\i = iCount
 
 ProcedureReturn #RET_OK
EndProcedure

Procedure.i GetFreePhysicalMemory (*qMemoryFree.Quad)

; DESC
; 	Get the the size in bytes of the free physical memory. 
;
; OUT
; 	*qMemoryFree    ; Pointer to a quad that will contain the size in bytes.
;
; RET
;  #RET_OK
;  #ERR_CALL_FAILED
;
; OS
;  Windows
  
 Protected tMemoryStatus.MEMORYSTATUS, tMemoryStatusEx.MEMORYSTATUSEX
 Protected *fpFunc
 Protected hDLL = OpenLibrary (#PB_Any, "kernel32.dll")
  
 If hDLL
    If OSVersion() >= #PB_OS_Windows_2000     
        tMemoryStatusEx\dwLength = SizeOf(MEMORYSTATUSEX)
        *fpFunc = GetFunction(hDLL, "GlobalMemoryStatusEx")
        If *fpFunc And CallFunctionFast(*fpFunc, @tMemoryStatusEx)
            *qMemoryFree\q = tMemoryStatusEx\ullAvailPhys
        EndIf
    Else     
        tMemoryStatus\dwLength = SizeOf(MEMORYSTATUS)      
        *fpFunc = GetFunction(hDLL, "GlobalMemoryStatus")
        If *fpFunc And CallFunctionFast (*fpFunc, @tMemoryStatus)
            *qMemoryFree\q = tMemoryStatus\dwAvailPhys
        EndIf
    EndIf
       
    CloseLibrary(hDLL)
    
    ProcedureReturn #RET_OK
 EndIf
 
 ProcedureReturn #ERR_CALL_FAILED           
 
EndProcedure

Procedure.i ReadPreferenceIntegerEx (Keyword$, iDefaultValue, iMin, iMax)

; DESC
; 	Like ReadPreferenceInteger() of PB, but with the addition of iMin - iMax range.
;  The read value is checked against the range and clamped to it.
;
; IN
; 	Keyword$        ; The keyword to be looked for in the preference file.
; 	iDefaultValue   ; The default value if the keyword cannot be found.
;  iMin            : Low limit for the possible accepted range (not checked if #PB_Ignore).
;  iMax            : High limit for the possible accepted range (not checked if #PB_Ignore).
;
; RET
;  The value read from the preference file, processed as needed.
;
; NOTES
;  Useful to return a plausible value if the preference file has been tampered with.

 Protected iRetVal = ReadPreferenceInteger (Keyword$, iDefaultValue)
 
 If iMin <> #PB_Ignore
    If iRetVal < iMin
        iRetVal = iMin
    EndIf
 EndIf
 
 If iMax <> #PB_Ignore
     If iRetVal > iMax
        iRetVal = iMax
     EndIf
 EndIf
 
 ProcedureReturn iRetVal  
EndProcedure

Procedure.s FixPathEndChar (Path$)

; DESC
;  Add the missing "\" or "/" (depending on the OS) at the end of the passed path, if needed.
;
; IN
; 	Path$   ; The full path we want to fix.
;
; RET
;  The full path with the added path delimiter at the end (if needed).
;
; NOTE
;	This is useful to normalize a path to a common format, as some routines returns a path with a traling "\" while others don't.
     
 If Len(Path$)
    If Right(Path$,1) <> #PATH_DELIMITER$
        ProcedureReturn Path$ + #PATH_DELIMITER$
    EndIf
 EndIf
 ProcedureReturn Path$    
EndProcedure

Procedure IsDirThere (Path$)

; DESC
; 	Return #True if the specified directory exists.
;
; IN
; 	Path$Dir    ; A string or string literal containing the directory path.
;
; RET
;  #True or #False

 ProcedureReturn Bool(FileSize(FixPathEndChar(Path$)) = -2)
EndProcedure 

Prototype.i proto_SetWindowTheme (hWnd, SubAppName.p-unicode, SubIdList.p-unicode) 

Procedure.i SetWindowTheme (hWnd, SubAppName$, SubIdList$)

; DESC
; 	Causes a window to use a different set of visual style information than its class normally uses.
;
; IN
;  hWnd        ; Handle of the window.
;  SubAppName$ ; A string that contains the application name to use in place of the calling application's name. 
;  SubIdList$  ; A string that contains a semicolon-separated list of class identifier (CLSID) names to use in place of the actual list passed by the window's class.
; 	
; RET
;   0  if successful
;  -1  if themes not available
;
; EXAMPLE
;  SetWindowTheme (GadgetID(1), "", "")    ; disable themes for the PB gadget num. 1
;
; NOTES
;  If SubAppName$ and SubIdList$ are empty, the themes are disabled for the specified window / gadget.
;
; OS
;  Windows

 Protected fpSetWindowTheme.proto_SetWindowTheme
 Protected hDll, iRetVal
 
 iRetVal = -1 ; themes not available
 
 hDll = OpenLibrary(#PB_Any, "UxTheme.dll")
 
 If hDll And OSVersion() >= #PB_OS_Windows_XP
    fpSetWindowTheme = GetFunction(hDll, "SetWindowTheme")
    iRetVal = fpSetWindowTheme (hWnd, SubAppName$, SubIdList$)
    CloseLibrary(hDll)
 EndIf
 
 ProcedureReturn iRetVal 
EndProcedure

Procedure StringGadget_SetLimit (nGadget, iSize)

; DESC
; 	Set the input char limit for the specified StringGadget gadget.
;
; IN
;  nGadget ; Number of the StringGadget gadget.
;  iSize   ; The max number of input chars allowed or 0 for no limits.
;
; OS
;  Windows

 SendMessage_(GadgetID(nGadget), #EM_LIMITTEXT, iSize, 0) 
EndProcedure

Procedure.s GetSpecialFolderLocation (iCSIDL)

; DESC
; 	Return the path of the specified system special folder.
;
; IN
; 	iCSIDL  ; CSIDL (constant special item ID list) value.
;
; RET
;  The special folder path or "" if not found.
;
; NOTES
;  For example if iCSIDL = #CSIDL_DESKTOPDIRECTORY it will return the path of the desktop.
;
; OS
;  Windows

 Protected iPIDL
 Protected SpecialFolderLocation$
 
 If SHGetSpecialFolderLocation_(#Null, iCSIDL, @iPIDL) = #S_OK
    SpecialFolderLocation$ = Space(#MAX_PATH)
    If SHGetPathFromIDList_(iPIDL, @SpecialFolderLocation$) = #False
        SpecialFolderLocation$ = ""
    EndIf    
 EndIf
  
 If iPIDL: CoTaskMemFree_ (iPIDL) : EndIf
  
 ProcedureReturn SpecialFolderLocation$
EndProcedure

Procedure.s GetDesktopPath()

; DESC
; 	Return the path of the Windows desktop.
;
; RET
;  The special folder path or "" if not found.
;
; SEE
;  GetSpecialFolderLocation()
;
; NOTES
;  A typical path is "C:\Documents and Settings\username\Desktop".
; 
; OS
;  Windows

 ProcedureReturn GetSpecialFolderLocation (#CSIDL_DESKTOPDIRECTORY)
EndProcedure 


Procedure.s Control_GetFontName (hWnd)

; DESC
; 	Get the font name for the specified gadget.
;
; IN
;  hWnd    ; Handle of the control.
;
; RET
;  The font name or "" if failed.
;  
; OS
;  Windows

 Protected tLOGFONT.LOGFONT 
 Protected hWrkFont, FontName$
 
 hWrkFont = SendMessage_(hWnd, #WM_GETFONT, 0, 0)
 
 If hWrkFont
    GetObject_(hWrkFont, SizeOf(LOGFONT), @tLOGFONT) 
    FontName$ = PeekS(@tLOGFONT\lfFacename[0])
 EndIf
 
 ProcedureReturn FontName$
EndProcedure 

Procedure.i Control_GetFontSize (hWnd)

; DESC
; 	Get the font size for the specified gadget.
;
; IN
;  hWnd    ; Handle of the control.
;
; RET
;  The font size or 0 if failed.
;  
; OS
;  Windows

 Protected tLOGFONT.LOGFONT 
 Protected hWrkFont, iFontSize
 
 hWrkFont = SendMessage_(hWnd, #WM_GETFONT, 0, 0)
 
 If hWrkFont
    GetObject_(hWrkFont, SizeOf(LOGFONT), @tLOGFONT) 
    iFontSize = tLOGFONT\lfHeight: If iFontSize < 0: iFontSize = -iFontSize: EndIf
    iFontSize = iFontSize * 72.0 / GetDeviceCaps_(GetDC_(GetDesktopWindow_()), #LOGPIXELSY)
 EndIf

 ProcedureReturn iFontSize
EndProcedure 

Prototype.i proto_EmptyWorkingSet (hProcess)

Procedure.i EmptyWorkingSet (hProcess)

; DESC
; 	Removes as many pages as possible from the working set of the specified process.
;
; RET
;   #RET_OK
;   #ERR_CALL_FAILED   
;   #ERR_OS_NOT_SUPPORTED
;
; OS
;  Windows

 Protected fpEmptyWorkingSet.proto_EmptyWorkingSet
 Protected hDll, iRetVal
 
 hDll = OpenLibrary(#PB_Any, "Psapi.dll")
 
 ; Windows XP and later, Windows 2000 Professional, or Windows NT Workstation 4.0
 If hDll And (OSVersion() >= #PB_OS_Windows_2000 Or OSVersion() = #PB_OS_Windows_NT_4)
    fpEmptyWorkingSet = GetFunction(hDll, "EmptyWorkingSet")
    
    If fpEmptyWorkingSet
        If fpEmptyWorkingSet(hProcess) <> 0
            iRetVal = #RET_OK
        Else
            iRetVal = #ERR_CALL_FAILED
        EndIf
    Else
        iRetVal = #ERR_CALL_FAILED
    EndIf
        
    CloseLibrary(hDll)
 Else
    iRetVal = #ERR_OS_NOT_SUPPORTED
 EndIf
 
 ProcedureReturn iRetVal 

EndProcedure

Procedure CenterWindowToDesktop (hWndChild, flgShow = #True)

; DESC
; 	Center the child window to the desktop.
;
; IN
;  hWndChild   ; Handle of the child window to be centered
;  flgShow     ; True if the window must be made visible after centering it
; 
; OS
;  Windows

 Protected tWinChild.T_WINDOW_RECT, tWinParent.T_WINDOW_RECT
 Protected iFlags = #SWP_NOSIZE | #SWP_NOZORDER 

 GetWindowBoundRect(hWndChild, @tWinChild)
 
 tWinParent\X = 0
 tWinParent\Y = 0
 tWinParent\W = GetDesktopWidth()
 tWinParent\H = GetDesktopHeight()
 
 CalcRectPosToRectCenter(@tWinChild, @tWinParent)
 
 If flgShow 
    iFlags | #SWP_SHOWWINDOW	
 EndIf
 
 SetWindowPos_(hWndChild, 0, tWinChild\X, tWinChild\Y, 0, 0, iFlags)
 
EndProcedure

Procedure ListIconGadget_SetColumnAlignment (nGadget, iCol, iAlign)

; DESC
;  Set the alignment type of the column iCol of the ListIconGadget nGadget to iAlign.
;
; IN
;  nGadget ; Number of the ListIconGadget gadget.
;  iCol    ; Number of the column (0 is the first one).
;  iAlign  ; #LVCFMT_CENTER, #LVCFMT_LEFT, #LVCFMT_RIGHT
;
; NOTES
;  The alignment of the leftmost column is always left-justified, it cannot be changed.
;
; OS
;  Windows

 Protected tCol.LV_COLUMN
 
 tCol\mask = #LVCF_FMT
 tCol\fmt = iAlign
 
 SendMessage_(GadgetID(nGadget), #LVM_SETCOLUMN, iCol, @tCol)
EndProcedure


Procedure SubclassWindow (hWnd, *fpNewWinProc, PropID$ = "oldWinProc")

; DESC
;  Change the winproc for the specified window to the procedure pointed by *fpNewWinProc.
;  Store the original winproc address in property PropID$ using the SetProp() API.
;
; IN
;  hWnd    ; Handle of the window.
;
; NOTES
;  Remember to free the prop catching the WM_DESTROY message in the callback:
;  
;  Case #WM_NCDESTROY: 
;      RemoveProp_(hWnd, "oldWinProc")
;
; OS
;  Windows

 SetProp_(hWnd, PropID$, GetWindowLongPtr_(hWnd, #GWL_WNDPROC))   
 
 SetWindowLongPtr_(hWnd, #GWL_WNDPROC, *fpNewWinProc) 
 
EndProcedure  

Procedure.i SplitStringToWords (Buff$, Delimiters$, List Words$(), iFlags = #Null)

; DESC
;  Split a string in its components (words) using the specified delimiters to identify the start of a new word. 
;  The resulting collection of words is stored in the linked list passed as parameter.
;  
; IN
; 	Buff$       ; The string to be processed.
; 	Delimiters$ ; The string containing the single char delimiters concatenated.
;  iFlags      ; #Null                     - Default.
;                #K_SPLIT_KEEP_DELIMITER   - To include the delimiters in the resulting list.
;
; OUT
; 	Words$()   ; The destination list
;
; RET
;  The number of words added to the list.
;
; EXAMPLE
;	iRetVal = SplitStringToWords ("Hi, we are some words.", " ,.", Words$())
;
; NOTES
;	The list is not cleared before processing, so results will be appended to the previous contents, if any.
;  Test program: SplitStringToWords.pb

 Protected Word$, Char$, iIndex, iCount, iPos
 Protected iLen = Len(Buff$)
 
 If iLen
    For iIndex = 1 To iLen
        Char$ = Mid(Buff$, iIndex, 1)                
        iPos = FindString (Delimiters$, Char$, 1) 
        If iPos ; if the char is a delimiter            
            If Len(Word$) ; and we have something in the word                
                AddElement(Words$())
                Words$() = Word$
                iCount + 1
                Word$ = ""
            EndIf
            If iFlags & #K_SPLIT_KEEP_DELIMITER ; we have to keep the delimiters too
                AddElement(Words$())
                Words$() = Mid(Delimiters$, iPos, 1)
                iCount + 1
            EndIf
        Else
            Word$ + Char$        
        EndIf        
    Next
    
    If Len(Word$) ; we have a pending word
        AddElement(Words$())
        Words$() = Word$ 
        iCount + 1   
    EndIf
 EndIf
   
 ProcedureReturn iCount
 
EndProcedure 

Procedure FreeImageEx (nImage)

; DESC
; 	Like FreeImage() but doesn't raise an error if nImage is invalid.
;  
; IN
; 	nImage  ; The Image id number


 If IsImage(nImage)
    FreeImage(nImage)
 EndIf
EndProcedure

; IDE Options = PureBasic 6.03 LTS (Windows - x86)
; CursorPosition = 1221
; FirstLine = 1221
; Folding = ---------
; EnableXP
; EnableUser
; Executable = ..\out64\i2pdf.exe
; CPU = 1
; CompileSourceDirectory